#ifndef GEN_H
#define GEN_H

typedef struct entry {
    room* area ;
    int weight ;
} entry ;

typedef struct fct_entry {
    int id ;
    char* name ;
    void (*updatePos)(double x, double y, double z, double w, double h, double d, double hz_angle, double vt_angle, float dtime, cube_0* ret) ;    
    // act as velocity function
    void (*onHit)(float dtime, int* hp, int* dmg, cube_0* ret) ;
    // triggers when object is hit
    void (*onDeath)(float dtime) ;
} fct_entry ;

void init_ent_generator(int n);

void copy_room(room* src, room* dest, int chx, int chy) ;
void build_starting_chunk(int chx, int chy) ;

void init_hashtbl() ;

void get_number_blocks(int* ret_cubes, int* ret_tps, int* ret_ent, FILE* ptr) ;
void align_to(FILE* ptr, char ch) ;
int read_int(FILE* ptr, bool print) ;
double read_float(FILE* ptr) ;
void parse_one_room(int id, char* filename) ;
void parse_rooms(int n_rooms) ;

void generate_nearby_chunks(int render_dist) ;

void free_pool();

#endif